# chaine.spec
# Specification algebrique des chaines de caracteres
# Auteur : VOURIOT Thierry
# Date : 4 novembre 2001

spec BSUP	
	operations	
		n: -> Nat
fspec

spec CHAINE(BSUP) etend BASE

	sorte Chaine

	operations

		chnouv: -> Chaine		#Creation d'une nouvelle chaine
		vide: Chaine -> Bool		#Test si une chane est vide
		at: Chaine Car -> Chaine	#Adjonction en tete
		aq: Chaine, Car  Chaine		#Adjonction en queue
		lgr: Chaine -> Nat		#Longueur
		t: Chaine -> Car		#Tete
		q: Chaine -> Car		#Queue
		co: Chaine -> Chaine		#Corps
		ci: Chaine -> Chaine		#Corps inverse
		sch: Chaine Nat Nat -> Chaine	#Sous-chaine
		conc: Chaine Chaine -> Chaine	#Concatenation
		sing: Car -> Chaine		#Singleton
		lirech: -> Chaine		#Lire une chaine au clavier
		ecrch: Chaine -> 		#Afficher une chaine a l'ecran
		copiech: Chaine -> Chaine	#Copie
		destch: Chaine ->		#Destruction
	

	preconditions 

		pre at(s,c) = pr aq(s,c) = lgr(s) < n
		pre t(ch) = pr q(ch) = non vide(ch)
		pre sch(ch,d,l) = d + l <= lgr(ch)
		pre conc(ch1,ch2) = lgr(ch1) + lgr(ch2) <= n


	axiomes 
		#Constructeurs chnouv et aq

		vide(chnouv) = vrai
		vide(aq(ch,x)) = faux

		at(chnouv,x) = aq(chnouv,x)
		at(aq(ch,y),x) = aq(at(ch,x),y)

		lgr(chnouv) = 0
		lgr(aq(ch,x)) = lgr(ch) + 1
	
		t(aq(chnouv,x)) = x
		t(aq(aq(ch,x),y)) = t(aq(ch,x))

		q(aq(ch,x)) = x

		co(chnouv) = chnouv
		co(aq(ch,x)) = aq(co(ch),x)

		ci(chnouv) = chnouv
		ci(aq(ch,x)) = ch	
	
		sch(ch,i,lg) = chres
			avec (chres,k) = init(chnouv,i)
			tantque k <= lg
			rep (aq(chres,ch[k]),k+1) frep

		conc(ch1,chnouv) = ch1
		conc(ch1,aq(ch2,x)) = aq(conc(ch1,ch2),x)

		sing(x) = aq(chnouv,x)

		lirech = avec x = donnee
			si s==\n alors chnouv
			sinon at(lirech,x) fsi

		ecrch(ch) = si lgr(ch)==1 alors ecrire(t(ch))
			sinon ecrch(ci(ch)) fsi

		copiech(ch) = chres
			avec (chres,i) = init(chnouv,0)
			tantque i < lgr(ch)
			rep (aq(chres,ch[i]),i+1) frep


fspec
